\documentclass[ucs,10pt]{beamer}

\input{inc/head_pres}

% Copyright 2004 by Till Tantau <tantau@users.sourceforge.net>.
%
% In principle, this file can be redistributed and/or modified under
% the terms of the GNU Public License, version 2.
%
% However, this file is supposed to be a template to be modified
% for your own needs. For this reason, if you use this file as a
% template and not specifically distribute it as part of a another
% package/program, I grant the extra permission to freely copy and
% modify this file as you see fit and even to delete this copyright
% notice.
%
% Modified by Tobias G. Pfeiffer <tobias.pfeiffer@math.fu-berlin.de>
% to show usage of some features specific to the FU Berlin template.

% remove this line and the "ucs" option to the documentclass when your editor is not utf8-capable
\usepackage[utf8x]{inputenc}    % to make utf-8 input possible
\usepackage[english]{babel}     % hyphenation etc., alternatively use 'german' as parameter
\usepackage{nth}

\include{fu-beamer-template}  % THIS is the line that includes the FU template!

%\usepackage{arev,t1enc} % looks nicer than the standard sans-serif font
% if you experience problems, comment out the line above and change
% the documentclass option "9pt" to "10pt"

% image to be shown on the title page (without file extension, should be pdf or png)
%~ \titleimage{./gfx/title.png}

\title%[Unfitted FEM for particle interaction] % (optional, use only with long paper titles)
{Equilibrium Finding and Abstraction in Games of Imperfect Information} % The space between to lines looks weirdly close when there is a line break. How can the problem be solved more elegantly?

%\subtitle{Include Only If Paper Has a Subtitle}

\author{Tobias Kies}
% - Give the names in the same order as the appear in the paper.

\institute[FU Berlin] % (optional, but mostly needed)
{Freie Universität Berlin}
% - Keep it simple, no one is interested in your street address.

\date % (optional, should be abbreviation of conference name)
{May \nth{23}, 2019}
% - Either use conference name or its abbreviation.
% - Not really informative to the audience, more for people (including
%   yourself) who are reading the slides online

%\subject{Theoretical Computer Science}
% This is only inserted into the PDF information catalog. Can be left
% out.

% you can redefine the text shown in the footline. use a combination of
% \insertshortauthor, \insertshortinstitute, \insertshorttitle, \insertshortdate, ...
\renewcommand{\footlinetext}{\insertshortinstitute, \insertshorttitle, \insertshortdate}

% Delete this, if you do not want the table of contents to pop up at
% the beginning of each subsection:
\AtBeginSubsection[]
{
  \begin{frame}<beamer>{Outline}
    \tableofcontents[currentsection,currentsubsection]
  \end{frame}
}


{\renewcommand{\arraystretch}{1.6}%
\newcommand{\gooditem}[1]{\setbeamercolor{item}{fg=green}\item #1}
\newcommand{\baditem}[1]{\setbeamercolor{item}{fg=red}\item #1}
\newcommand{\neutralitem}[1]{\setbeamercolor{item}{fg=structure}\item #1}
\newcommand{\futureitem}[1]{\setbeamercolor{item}{fg=yellow}\item #1}

\newcommand{\sectionslide}[1]{%
\begin{frame}[plain]%
  \begin{center}\textbf{\huge\textcolor{fu-light-blue}{#1}}\end{center}%
\end{frame}%
}

\newcommand{\iarrow}{\raisebox{0.1em}{\textcolor{fu-blue}{$\blacktriangleright$}}}
\newcommand{\arlb}{\raisebox{0.1em}{\textcolor{emph-color}{$\blacktriangleright$}}}
\newcommand{\ardb}{\raisebox{0.1em}{\textcolor{fu-blue}{$\blacktriangleright$}}}

\begin{document}

\begin{frame}[noframenumbering, plain]
  \vfill
  \begin{center}
    \includegraphics[width=0.5\textwidth]{joke.jpg}
  \end{center}
  \vfill
\end{frame}

\begin{frame}[plain]
  \titlepage
\end{frame}

%\begin{frame}{Outline}
%  \tableofcontents
%  % You might wish to add the option [pausesections]
%\end{frame}


\begin{frame}{Libratus poker AI}
  % --- Storytelling ---
  % * AI breakthrough: Libratus beats (very) top professionals at poker
  % * This is in a broader view important because this is about the more general
  %   class of imperfect information games, ...
  % * ... which conceptionally is more challenging to solve than perfect information
  %   games (such as chess and go).
  % * But this is interesting because arguably the most relevant real-world
  %   applications lead to imperfect information games rather than perfect information
  %   games.
  \begin{itemize}[itemsep=1.5em]
    \item
      \hspace{2em}\includegraphics[width=0.7\textwidth]{science-article}
      \footnotetext[1]{\scriptsize Science 26 Jan 2018: Vol.\,359, Issue 6374, pp.\,418--424}
      
    \item[\iarrow]
      %~ Poker:
      Benchmark for \ssubcapbf{imperfect information game solvers}
      
    \item[\iarrow]
      \ssubcapbf{Game theoretic} approach
    
    %~ \item[\iarrow] More challenging than perfect information games (chess, go, ...)
    
    \item[\iarrow] Real-world applications: automated negotiation, trading,
      \newline cyber-security, medical treatment planning, \dots
  \end{itemize}
\end{frame}


\begin{frame}{Quick intro: Texas hold 'em poker}
  % To-do: Maybe add some pictures here to help visualization.
  \setbeamercovered{transparent}
  \begin{itemize}[itemsep=0.75em]
    \item[\ardb] Each players gets 2 private cards
    \item[\arlb]<2-> Betting round
    \item[\ardb]<3-> 3 public cards are dealt
    \item[\arlb]<4-> Betting round
    \item[\ardb]<5-> 1 more public card is dealt
    \item[\arlb]<6-> Betting round
    \item[\ardb]<7-> 1 final public card is dealt
    \item[\arlb]<8-> Betting round
    \item[\ardb]<9-> Showdown: Best combination of 5 (private + public cards) wins
    %~ \item[\ardb] Each players gets 2 private cards
    %~ \item[\arlb] Betting round
    %~ \item[\ardb] 3 public cards are dealt
    %~ \item[\arlb] Betting round
    %~ \item[\ardb] 1 more public card is dealt
    %~ \item[\arlb] Betting round
    %~ \item[\ardb] 1 final public card is dealt
    %~ \item[\arlb] Betting round
    %~ \item[\ardb] Showdown: Best combination of 5 (private + public cards) wins
  \end{itemize}
  
  \setbeamercovered{invisible}
  \vspace{0.5em}
  \begin{center}
    \uncover<10->{
    %~ \uncover<2->{
      %~ \textbf{Complexity heads-up (Johanson '13):} \textbf{\emph{$\sim 10^{161}$}} decision points
      \textbf{Johanson '13:} \textbf{\emph{$\bm{\sim 10^{161}}$}} decision points
      %~ \footnote[2]{\scriptsize M.\,Johanson, ``Measuring the size of large no-limit poker games.'' (Technical Report, Univ. of Alberta Libraries, 2013.}
      }
  \end{center}
  
  %~ \only<1>{\hspace*{+65mm}\raisebox{60mm}[0mm][0mm]{\emph{TODO: Picture 1}}}
  %~ \only<2>{\hspace*{+65mm}\raisebox{60mm}[0mm][0mm]{\emph{TODO: Picture 2}}}
  %~ \only<3>{\hspace*{+65mm}\raisebox{60mm}[0mm][0mm]{\emph{TODO: Picture 3}}}
  %~ \only<4>{\hspace*{+65mm}\raisebox{60mm}[0mm][0mm]{\emph{TODO: Picture 4}}}
  %~ \only<5>{\hspace*{+65mm}\raisebox{60mm}[0mm][0mm]{\emph{TODO: Picture 5}}}
  %~ \only<6>{\hspace*{+65mm}\raisebox{60mm}[0mm][0mm]{\emph{TODO: Picture 6}}}
  %~ \only<7>{\hspace*{+65mm}\raisebox{60mm}[0mm][0mm]{\emph{TODO: Picture 7}}}
  %~ \only<8>{\hspace*{+65mm}\raisebox{60mm}[0mm][0mm]{\emph{TODO: Picture 8}}}
  %~ \uncover<9->{\hspace*{+65mm}\raisebox{60mm}[0mm][0mm]{\emph{TODO: Picture 9}}}
\end{frame}


\begin{frame}{Core concepts behind Libratus}
  % Box example from
  % http://www.texample.net/tikz/examples/boxes-with-text-and-math/
  % Remarkable (almost game theory only!)
  \tikzstyle{corebox} = [draw=fu-light-blue, fill=fu-light-blue!20, thick,
    rectangle, inner sep=10pt, inner ysep=15pt]
  \tikzstyle{fancytitle} =[fill=fu-light-blue, text=white]

  \vspace{0.5em}
  \hspace{-1.8em}
  \begin{tikzpicture}
    \node [corebox, minimum height=12em] (box-abstraction) at (0, 0){%
        \begin{minipage}{8em}
          \vspace{1.5em}
          %~ \textcolor{fu-light-blue!20}{Approximate game by smaller one.}
          \textcolor{black}{\ reduce game size \newline \ }
          %~ small game
          
          \vspace{3em}
          
          %~ \textcolor{fu-light-blue!20}{Determine a (near) optimal strategy.}
          \textcolor{black}{\ optimal strategy \newline \ }
        \end{minipage}
    };
    \node[fancytitle, right=10pt] at (-3.8em,4em) {Abstraction};
    \node[fancytitle, right=10pt] at (-5.4em,-1em){Equilibrium finding};
    
    \node [corebox, minimum height=12em] (box-endgame) at (4.2, 0){%
        \begin{minipage}{8em}
          \vspace{1em}
          %~ \textcolor{fu-light-blue!20}{Solve a fine-grained abstraction online during late game.}
          \textcolor{black}{online, fine-grained computations}
        \end{minipage}
    };
    \node[fancytitle, right=10pt] at (7.3em,2.5em)  {Endgame solver};
    
    \node [corebox, minimum height=12em] (box-improver) at (8.4, 0){%
        \begin{minipage}{8em}
          \vspace{1em}
          %~ \textcolor{fu-light-blue!20}{Discover critical exploitabilities during gameplay.}
          \textcolor{black}{find exploitabilities \newline \ }
        \end{minipage}
    };
    \node[fancytitle, right=10pt] at (19.8em,2.5em) {Self-improver};
    
    \draw[stealth-,ultra thick,rounded corners=100,color=fu-blue] (-2em,-6.5em) arc (225:315:18em) node[midway,below] {\small Local abstraction improvement + equilibrium update};

    \draw[-stealth,ultra thick,rounded corners=100,color=fu-blue] (2em,-6.5em) arc (225:315:7em) node[midway,below] {\small Blueprint strategy};
    
    \uncover<2->{
      \draw[scale=1.0,domain=0.5:8,smooth,variable=\t,red,ultra thick]
        plot ({cos(deg(\t))*(1.5+0.25*exp(-0.1*\t)},{2*sin(deg(\t))*(1+0.25*exp(-0.1*\t)});
    }
  \end{tikzpicture}
  
  %~ \uncover<2->{
    %~ \begin{center}
      %~ \hspace{-1.8em}$\leadsto$ Predominantly based on general \textbf{game theoretic principles}
    %~ \end{center}
  %~ }
\end{frame}


\newcommand{\Vleaf}{V_{\text{leaf}}}
\begin{frame}{What is a game of imperfect information?}
  \begin{itemize}[itemsep=2em]
    %~ \item
      %~ \textbf{Definition:}
      %~ An \ssubcapbf{extensive form game} (EFG) is a tuple~$(V,E,P,\cI,\cA,u,p)$ where:
      %~ \vspace{0.2em}
      %~ \begin{itemize}[itemsep=0.5em] % Using enumerate causes an error. Why?
        %~ \item[1.] $(V,E)$ is a \ssubcapbf{tree}. Leaf nodes are denoted by $\Vleaf$.
        %~ \item[2.] $P\colon V\setminus \Vleaf \rightarrow \{0,\dots,n\}$ maps \ssubcapbf{vertices to players}.
          %~ \newline Player~$0$ is the ``chance player''.
          %~ \newline The set of the $k$-th player's nodes is denoted by $P_k := P^{-1}(\{k\})$.
        %~ \item[3.] $\cI = (\cI_0,\dots,\cI_n)$ is such that every $\cI_k$ is a partition of the $k$-th player's nodes $P_k$.
          %~ Every element $I \in \cI_k$ is called an \ssubcapbf{information set}.
        %~ \item[4.] $\cA = (\cA_0,\dots,\cA_n)$ is such that every $\cA_k = (\cA_{k,I})_{I \in \cI_k}$ is a family of partitions of $\{(x,y) \in E \mid x \in I\}$ such that the edges in each $a \in \cA_{k,I}$ are pairwise disjoint.
          %~ Every element $a \in \cA_{k,I}$ is called an \ssubcapbf{action}.
        %~ \item[5.] $u\colon \Vleaf \rightarrow \R^n$ is the \ssubcapbf{utility function}.
          %~ %%~ \newline The game is called a \ssubcapbf{zero-sum game} if $\sum_{i=1}^n u_i \equiv 0$.
        %~ \item[6.] $p = (p_I)_{I \in \cI_0}$ is a family of probability density functions $p_I\colon I \rightarrow [0,1]$ over the information sets of the \ssubcapbf{chance player}.
      %~ \end{itemize}
    \item
      %~ \textbf{Definition}
      \ssubcapbf{Extensive Form Game:}
      tuple~$(V,E,P,\cI,\cA,u,p)$
      \vspace{0.2em}
      \begin{itemize}[itemsep=0.5em] % Using enumerate causes an error. Why?
        \item[1.] \ssubcapbf{Tree} $(V,E)$
        \item[2.] \ssubcapbf{Player map} $P\colon V\setminus \Vleaf \rightarrow \{0,\dots,n\}$
          \begin{itemize}
            \item[\iarrow] Chance player $0$
            \item[\iarrow] Player nodes $P_k = P^{-1}(\{k\})$
          \end{itemize}
        \item[3.] \ssubcapbf{Information sets} $I \in \cI_k$
          \begin{itemize}
            \item[\iarrow] $\cI_k$ partition of $P_k$
          \end{itemize}
        \item[4.] \ssubcapbf{Actions} $a \in \cA_{I}$
          \begin{itemize}
            \item[\iarrow] $\cA_{I}$ partition of $\{(x,y) \in E \mid x \in I\}$
            \item[\iarrow] Pairwise disjoint edges $a, \wt{a} \in \cA_{I}$
          \end{itemize}
        \item[5.] \ssubcapbf{Utility function} $u\colon \Vleaf \rightarrow \R^n$
          %~ \newline The game is called a \ssubcapbf{zero-sum game} if $\sum_{i=1}^n u_i \equiv 0$.
        \item[6.] \ssubcapbf{Chance probabilities} $p_I \colon \cA_I \rightarrow [0,1]$ for $I \in \cI_0$
      \end{itemize}
  \end{itemize}
\end{frame}


\tikzset{
    playernode/.style={
        draw=blue,
        fill=white,
        circle,
        ultra thick
    }
}

\tikzset{
    utilitynode/.style={
        circle,
        draw=blue,
        fill=white,
        ultra thick
    }
}

\tikzset{
    gameedge/.style={
      ultra thick
    }
}

\tikzset{
    informationedge/.style={
      draw=brown,
      densely dashed,
      ultra thick
    }
}

\tikzset{
    gameedgeincom/.style={
      loosely dotted,
      ultra thick
    }
}

\newlength{\dpad}
\setlength{\dpad}{4.0em}
%~ \newcommand{\dpad}{4.0em}
\newcommand{\Nt}[1]{\textcolor{red}{#1}}
\newcommand{\ut}[2]{\textcolor{purple}{$#1, #2$}}
\newcommand{\pt}[2]{\textcolor{orange}{$#1/#2$}}
\newcommand{\at}[1]{\textcolor{fu-green}{\textbf{#1}}}

\begin{frame}{Example: an extensive form game}
  \large
  $(\textcolor{blue}{V},E,\textcolor{red}{P},\textcolor{brown}{\cI},\textcolor{fu-green}{\cA},\textcolor{purple}{u},\textcolor{orange}{p})$
  \vspace{1em}
  
  \begin{tikzpicture}
    \node[playernode] (nA) {\Nt{0}};
    \node[playernode] (nB) at ([xshift=-2\dpad,yshift=-1.2\dpad]nA) {\Nt{1}};
    \node[playernode] (nC) at ([xshift=-1.75\dpad,yshift=-1.2\dpad]nB) {\Nt{2}};
    \node[playernode] (nD) at ([xshift=+1.75\dpad,yshift=-1.2\dpad]nB) {\Nt{2}};
    
    \node[utilitynode] (uA) at ([xshift=+2\dpad,yshift=-1.2\dpad]nA) {\ut{1}{0}};
    \node[utilitynode] (uB) at ([xshift=-0.75\dpad,yshift=-1.2\dpad]nC) {\ut{1}{0}};
    \node[utilitynode] (uC) at ([xshift=+0.75\dpad,yshift=-1.2\dpad]nC) {\ut{0}{1}};
    \node[utilitynode] (uD) at ([xshift=-0.75\dpad,yshift=-1.2\dpad]nD) {\ut{0}{1}};
    \node[utilitynode] (uE) at ([xshift=+0.75\dpad,yshift=-1.2\dpad]nD) {\ut{1}{0}};
    
    %~ \node[stealth-,ultra thick,rounded corners=100,color=fu-blue] (nA) -- (nB) node[midway,left] {\pt{3}{4}};
    \draw[gameedge] (nA) -- (nB) node[midway,left] {\pt{3}{4}\phantom{1.}};
    \draw[gameedge] (nA) -- (uA) node[midway,right] {\phantom{1.}\pt{1}{4}};
    
    \draw[gameedge] (nB) -- (nC) node[midway,left] {\at{L}\phantom{1.}};
    \draw[gameedge] (nB) -- (nD) node[midway,right] {\phantom{1.}\at{R}};
    
    \draw[gameedge] (nC) -- (uB) node[midway,left] {\at{U}\phantom{1}};
    \draw[gameedge] (nC) -- (uC) node[midway,right] {\phantom{1}\at{D}};
    \draw[gameedge] (nD) -- (uD) node[midway,left] {\at{U}\phantom{1}};
    \draw[gameedge] (nD) -- (uE) node[midway,right] {\phantom{1}\at{D}};
    
    \draw[informationedge] (nC) -- (nD);
  \end{tikzpicture}
\end{frame}


\begin{frame}{Perfect recall in EFGs}
  \begin{itemize}[itemsep=2em]
    \item
      %~ \ssubcapbf{Perfect-recall}
      For every player~$k$ and every information~set~$I \in \cI_k$:
      \vspace{0.2em}
      \begin{itemize}[itemsep=0.5em]
        %~ \item[1.] Any path in $(V,E)$ intersects $I$ at most once.
        \item[1.] every path in $(V,E)$ intersects $I$ at most once
        \item[2.] every path $(x_1, \dots, x_n)$ and every $y_n \in I(x_n)$ admits a path~$(y_1, \dots, y_n)$ with
          \begin{equation*}
            P(x_i) = P(x_n) \ \Longrightarrow \ (x_i,x_{i+1}) \equiv (y_i, y_{i+1}) \text{ in } \cA(x_i)
          \end{equation*}
        %~ \emph{For every $y,\wt{y} \in I$ and predecessor $x \in P_k$ of $y$, there is a predecessor $\wt{x} \in P_k$ of $\wt{y}$ such that the actions taken along the path from $x$ to $y$ are identical to the ones taken from $\wt{x}$ to $\wt{y}$.}
      \end{itemize}
  \end{itemize}
\end{frame}


\begin{frame}{Example: an EFG \emph{without} perfect recall}
  \begin{tikzpicture}
    \node[playernode] (nA) {\Nt{1}};
    
    \node[playernode] (nB) at ([xshift=-2\dpad,yshift=-1.3\dpad]nA) {\Nt{2}};
    \node[playernode] (nC) at ([xshift=+2\dpad,yshift=-1.3\dpad]nA) {\Nt{2}};
    
    \node[playernode] (nD) at ([xshift=-1\dpad,yshift=-1.3\dpad]nB) {\Nt{1}};
    \node[playernode] (nE) at ([xshift=+1\dpad,yshift=-1.3\dpad]nB) {\Nt{1}};
    \node[playernode] (nF) at ([xshift=-1\dpad,yshift=-1.3\dpad]nC) {\Nt{1}};
    \node[playernode] (nG) at ([xshift=+1\dpad,yshift=-1.3\dpad]nC) {\Nt{1}};
    
    \draw[gameedge] (nA) -- (nB) node[midway,left] {\at{L}\phantom{1.}};
    \draw[gameedge] (nA) -- (nC) node[midway,right] {\phantom{1.}\at{R}};

    \draw[gameedge] (nB) -- (nD) node[midway,left] {\at{U}\phantom{1}};
    \draw[gameedge] (nB) -- (nE) node[midway,right] {\phantom{1}\at{D}};
    \draw[gameedge] (nC) -- (nF) node[midway,left] {\at{U}{\phantom{1}}};
    \draw[gameedge] (nC) -- (nG) node[midway,right] {\phantom{1}\at{D}};
    
    \node (nH) at ([xshift=-0.6\dpad,yshift=-1.1\dpad]nD) {};
    \node (nI) at ([xshift=+0.6\dpad,yshift=-1.1\dpad]nD) {};
    \node (nJ) at ([xshift=-0.6\dpad,yshift=-1.1\dpad]nE) {};
    \node (nK) at ([xshift=+0.6\dpad,yshift=-1.1\dpad]nE) {};
    \node (nL) at ([xshift=-0.6\dpad,yshift=-1.1\dpad]nF) {};
    \node (nM) at ([xshift=+0.6\dpad,yshift=-1.1\dpad]nF) {};
    \node (nN) at ([xshift=-0.6\dpad,yshift=-1.1\dpad]nG) {};
    \node (nO) at ([xshift=+0.6\dpad,yshift=-1.1\dpad]nG) {};
    
    \draw[gameedgeincom] (nD) -- (nH) node[midway,left] {\at{F}};
    \draw[gameedgeincom] (nD) -- (nI) node[midway,right] {\at{B}};
    \draw[gameedgeincom] (nE) -- (nJ) node[midway,left] {\at{F}};
    \draw[gameedgeincom] (nE) -- (nK) node[midway,right] {\at{B}};
    \draw[gameedgeincom] (nF) -- (nL) node[midway,left] {\at{F}};
    \draw[gameedgeincom] (nF) -- (nM) node[midway,right] {\at{B}};
    \draw[gameedgeincom] (nG) -- (nN) node[midway,left] {\at{F}};
    \draw[gameedgeincom] (nG) -- (nO) node[midway,right] {\at{B}};
    
    \draw[informationedge] (nB) -- (nC);

    \draw[informationedge] (nD) -- (nE);
    \draw[informationedge] (nE) -- (nF);
    \draw[informationedge] (nF) -- (nG);
  \end{tikzpicture}
\end{frame}


\begin{frame}{What is a strategy?}
  \begin{itemize}[itemsep=2em]
    \item
      \begin{itemize}[itemsep=1.25em,leftmargin=-.5em]         
        \item \ssubcapbf{Behavioral strategy} $\sigma_k = (\sigma_{k,I})_{I \in \cI_k}$
          \begin{equation*}
            \sigma_{k,I}\colon \cA_{I} \longrightarrow [0,1], \qquad \sum_{a \in \cA_I} \sigma_{k,I}(a) = 1
          \end{equation*}

        \item \textbf{Pure strategies} %\ssubcapbf{Pure strategies}
          \begin{equation*}
            \cA_{k} := \textstyle\prod_{I \in \cI_k} \cA_I
          \end{equation*}
        
        \item \ssubcapbf{Mixed strategy}
          \begin{equation*}
            p_k\colon \cA_k \longrightarrow [0,1], \qquad \sum_{\mu \in \cA_k} p_k(\mu) = 1
          \end{equation*}
      \end{itemize}
    
      %~ \textbf{Definition:}
        %~ \begin{itemize}[itemsep=1.5em]
          %~ \item A \ssubcapbf{pure strategy} is a collection $\mu = (\mu_1,\dots,\mu_n)$
           %~ of maps $\mu_k\colon \cI_k \rightarrow \bigcup_{I \in \cI_k} \cA_{k,I}$ such that $\mu_k(I) \in \cA_{k,I}$ for all $I \in \cI_k$.
          %~ \item \ssubcapbf{Pure strategy} $\mu_k \in \prod_{I \in \cI_k} \cA_I =: \cA_k$
          %~ \vspace{0.4em}
          %~ \begin{itemize}[itemsep=0.5em]
            %%~ \item[\iarrow] \ssubcapbf{Mixed strategy} $p(\mu_k^i) \in [0,1]$
            %%~ \item[\iarrow] \ssubcapbf{Mixed strategy} $p_k\colon \prod_{I \in \cI_k} \cA_I \rightarrow [0,1]$
            %~ \item[\iarrow] \ssubcapbf{Mixed strategy} $p_k\colon \cA_k \rightarrow \Delta_k$
            %~ \item[\iarrow] \ssubcapbf{Mixed strategy} $p_k\colon \cA_k \rightarrow [0,1]$ %, $\sum_{\mu \in \cA_k} p_k(\mu) = 1$
            %~ \item[\iarrow] Standard simplex $\Delta_k \subseteq \R^{\abs{\cA_k}}$
          %~ \end{itemize}
          %~ \item \ssubcapbf{Behavioral strategy} $\sigma_{k, I}\colon \cA_I \rightarrow \Delta_I$, $I \in \cI_k$
          %~ \item \ssubcapbf{Behavioral strategy} $\sigma_{k, I}\colon \cA_I \rightarrow [0,1]$, $\forall I \in \cI_k$
          % \rightarrow \operatorname{Map}(\cA_I, \Delta_I)$
          %~ \vspace{0.25em}
          %~ \begin{itemize}
            %~ \item[\iarrow] Standard simplex $\Delta_I \subseteq \R^{\abs{\cA_I}}$
          %~ \end{itemize}
          
          %~ \item A \ssubcapbf{behavioral strategy} is a collection $\sigma = (\sigma_1,\dots, \sigma_n)$ where each $\sigma_k = (\sigma_{k, I})_{I \in \cI_k}$ is a family of probability density functions $\sigma_{k,I}\colon I \rightarrow [0,1]$.
          %~ \item The \ssubcapbf{expected utility} of a strategy $\sigma$ is denoted as $u(\sigma)$.
        %~ \end{itemize}
        
    \end{itemize}
    %~ \item<2->
    \pause
    \vspace{1.5em}
      \textbf{Kuhn's Theorem (1953):}
        For perfect-recall EFGs, given $p_k$
        %~ Equivalent strategies
      %~ \begin{itemize}[itemsep=0.5em]
        %~ \item
          %~ Given $\lambda \in \Delta_n$ and $\mu_k^1, \dots, \mu_k^n$
          \begin{align*}
            & \sigma_{k,I}(a) = \frac{\sum_{\mu_k \in \operatorname{R}(I), \mu_k(I) = a} p_k(\mu)}{\sum_{\mu_k \in \operatorname{R}(I)} p_k(\mu)} & & \forall{k}
            \\[1.0em] \qquad \implies & Pr(v | p ) = Pr(v | \sigma)& &  \forall{v \in \Vleaf} 
          \end{align*}
          
        
        
        %~ \item[1.] Every element-wise convex combination $\wt{\sigma} = (\sum_{i} \lambda_{k,i} \mu_{k,i})_k$ of pure strategies induces a behavioral strategy
          %~ \begin{equation*}
            %~ \sigma_{k,I}(a) = \frac{\sum_{\mu_{k,i} \in \operatorname{R}(I), \mu_{k,i}(I) = a} \lambda_{k,i}}{\sum_{\mu_{k,i} \in \operatorname{R}(I)} \lambda_{k,i}}
          %~ \end{equation*}
          
        %~ \item[2.] Conversely, each behavioral strategy is induced by a convex combination of pure strategies.
      %~ \end{itemize}
  %~ \end{itemize}
  %~ \emph{Open: Write down the relation in Kuhn's theorem? At least in a simplified formula?}
  %~ \emph{Is it valid for more than two players still?}
\end{frame}

\begin{frame}{What is a \textbf{good} strategy?}
  \begin{itemize}[itemsep=2em]
    \item
      \ssubcapbf{Expected utility} $u(\sigma) = u(\sigma_1,\dots,\sigma_n)$

    \item<1->
      %~ \textbf{Definition:}
        %~ \begin{itemize}[itemsep=0.5em]
          %~ \item Given $\epsilon \in [0,\infty)$, %]$
            %~ a strategy~$\sigma$ is called an
            %~ \ssubcapbf{$\epsilon$-Nash~equilibrium} if for every player $k$ and all strategies $\wt{\sigma}$ with $\sigma_j = \wt{\sigma}_j$ for $j \neq k$ holds
            %~ \begin{equation*}
              %~ u(\sigma) + \eps \geq u(\wt{\sigma})\text{.}
            %~ \end{equation*}
          %~ \item A $0$-Nash equilibrium is also called a \ssubcapbf{Nash equilibrium}.
        %~ \end{itemize}
        %~ \item
          \ssubcapbf{$\epsilon$-Nash equilibrium}
            \begin{itemize}
              \item
                For every player $k$ and all strategies $\wt{\sigma}$
            %~ with $\sigma_j = \wt{\sigma}_j$ for $j \neq k$ holds
                \begin{equation*}
                  \text{$\sigma_j = \wt{\sigma}_j \ \forall j \neq k$} \ \Longrightarrow \ u_k(\sigma) + \eps \geq u_k(\wt{\sigma})\text{.}
                \end{equation*}
            \end{itemize}
              %~ \item $\epsilon = 0$: \ssubcapbf{Nash equilibrium}.
            %~ \end{itemize}
        
      \item<2->
        \textbf{Nash's theorem (1951):}
          \begin{itemize}
            \item Every EFG with perfect recall has a 0-Nash equilibrium.
          \end{itemize}
          % Original proof using Brouwer fixed-point theorem, simpler version using Kakutani's fixed-point theorem.
  \end{itemize}
\end{frame}


\begin{frame}{Nash-equilibria in perfect-recall EFGs}
  \begin{itemize}[itemsep=1.0em]
    \item
      $n=2$ players
      
    \item
      \ssubcapbf{Zero-sum game:} $u_1 + u_2 \equiv 0$
      \vspace{1em}
      
    \pause
      
    \item
      $m_k = \abs{\cA_k}$ pure strategies, simplex $\Delta_k \subseteq \R^{m_k}$
      
    %~ \item
      %~ $k$-th player's pure strategies $(\mu_{k,i})_{i = 1,\dots, m_k}$
      
    %~ \item
      %~ standard simplices $\Delta_{k} := \left\{ x \in [0,1]^{m_k} \mid \sum_{i=1}^{m_k} x_i = 1 \right\}$
      
    \item
      \ssubcapbf{Payoff-matrix} $A = \big(u_2(\mu_1^i, \mu_2^j)\big) \in \R^{m_1 \times m_2}$

    \item
      \vspace{1em}
      \ssubcapbf{min-max matrix game problem}
      \vspace{0.4em}
      \begin{itemize}
        \item $\displaystyle \min_{x \in \Delta_1} \ \max_{y \in \Delta_2} \ x^T A y = \max_{y \in \Delta_2} \ \min_{x \in \Delta_1} \ x^T A y$
      \end{itemize}
      \vspace{1em}
      
    %~ \pause
    %~ \vspace{0.5em}
    %~ \item $\leadsto$ close relation to linear programming
  \end{itemize}
  %~ \emph{(fun question: lower semi-continuity?) and what does the formulation as linear program look like? refresher on primal-dual formulations?}
\end{frame}


\begin{frame}{Nash-equilibria in perfect-recall EFGs (2)}
  \begin{itemize}[itemsep=1.0em]
      \item \hspace{3em} $\displaystyle \min_{x \in \Delta_1} \ \max_{y \in \Delta_2} \ x^T A y = \max_{y \in \Delta_2} \ \min_{x \in \Delta_1} \ x^T A y$
      
      %~ \item Equivalent: dual \ssubcapbf{linear programs}
        %~ \begin{align*}
          %~ \min_{(x, M) \in \R^{m_1 + 1}} & \ M & \max_{(y,L) \in \R^{m_2 + 1}} & \ L
          %~ \\ A^Tx & \leq M & Ay & \geq L
          %~ \\ x & \geq 0 & y & \geq 0
          %~ \\ \textstyle\sum_{i=1}^{m_1} x_i & = 1 & \textstyle \sum_{i=1}^{m_2} y_i & = 1
        %~ \end{align*}
      
      %~ \item Equivalent \ssubcapbf{linear program}
      \item \ssubcapbf{Linear program}
        \begin{align*}
          \min_{(x, M) \in \R^{m_1 + 1}} & \ M 
          \\ A^Tx & \leq M
          \\ x & \geq 0
          \\ \textstyle\sum_{i=1}^{m_1} x_i & = 1 \text{\phantom{.}\hspace{17em}\phantom{.}}
        \end{align*}
        
      \pause
      \vspace{1em}
      \item
        %~ Challenges
        \begin{itemize}%[leftmargin=-.5em]
          \item[\arlb] \textbf{Excessive size of $A$}
          %~ \item[\arlb] direct/higher-order methods prohibitive
        \end{itemize}
        
      \item
        %~ Improvements
        \begin{itemize}%[leftmargin=-.5em]
          \item[\ardb] Sparse/low-rank representations
          \item[\ardb] Lower-dimensional formulations % using sequence form and treeplexes
          \item[\ardb] \textbf{Iterative first order methods}
          \item[\ardb] Monte--Carlo based methods
        \end{itemize}
  \end{itemize}

  \hspace*{+47mm}\raisebox{25mm}[0mm][0mm]{\includegraphics[width=0.6\textwidth]{improved_game_solving.png}}
  \hspace*{+100mm}\raisebox{26mm}[0mm][0mm]{\scriptsize (Sandholm '10)}
\end{frame}


\begin{frame}{Duality gap minimization}
  \begin{itemize}[itemsep=0.75em]
    \item
      \ssubcapbf{Dual non-smooth optimization problems}
      \begin{align*}
        f(x) & = \max_{v \in \Delta_2} \ x^TAv \quad \rightarrow \min \text{ in } \Delta_1
        \\ \phi(y) & = \min_{u \in \Delta_1} \ u^TAy \quad \rightarrow \max \text{ in } \Delta_2
      \end{align*}
      
    \item
      %~ \ssubcapbf{Gap function}
      \begin{equation*}
        F(x,y) = f(x) - \phi(y) \geq 0 = F(x^\ast, y^\ast)
      \end{equation*}
      
    \pause
    \vspace{1em}
    \item
      \ssubcapbf{Convex $C^{1,1}$-smoothing}
      \begin{equation*}
        F_\mu(x,y) = \max \left\{ x^T Av - u^TAy - \frac{\mu}{2} \norm{(u,v) - (\wt{u}, \wt{v})}^2 \ \Big\vert \ (u,v) \in \Delta_1 \times \Delta_2 \right\}
      \end{equation*}

    \item
      %~ $D := \operatorname{diam}(\Delta_1\times \Delta_2)$,
      %~ Uniform approximation property
      \vspace{0.5em}
      \begin{equation*}
        F_\mu \leq F \leq F_\mu + \mu
      \end{equation*}
  \end{itemize}
\end{frame}


\begin{frame}{An $\mathcal{O}(1/\eps)$ first order method}
  \begin{itemize}
    \item
      \textbf{Nesterov '05, Lan/Lu/Monteiro '11:}
      \begin{itemize}[itemsep=0.75em]
        \item First order method, $\mu := \eps/2$
        \item $F_\mu(x_k, y_k) \in \mathcal{O}(1/(\eps k^2))$
        \item $\eps$-Nash equilibrium in $k = \lceil 4 \norm{A} / \eps \rceil$ iterations
          \vspace{0.5em}
        %~ \newline Each iteration involves solving three sub-problems:
        %~ \begin{align*}
          %~ \max_{(a,b) \in \Delta_1 \times \Delta_2} & u_k^TAb - a^TAv_k
          %~ \\ \min_{(x,y) \in \Delta_1 \times \Delta_2} & \nabla F_\mu(u_k, v_k)^T \left( (x,y) - (u_k,v_k) \right) + \frac{\norm{A}^2}{2\mu} \norm{(x,y)-(u_k,v_k)}^2
          %~ \\ \min_{(w,z) \in \Delta_1 \times \Delta_2} & \sum_{i=0}^k \frac{i+1}{2} \nabla F_\mu(u_i,v_i)^T\left((w,z) - (u_i,v_i)\right)
          %~ \\ &\qquad + \frac{\norm{A}^2}{2\mu} \norm{(w,z) - (x_0,y_0)}^2
        %~ \end{align*}
        \pause
        \item
          \vspace{0.5em}
          %~ Requires knowledge of $\norm{A}$ and per iteration:
          Per iteration
          \begin{itemize}[itemsep=0.1em]
            \item[\iarrow] 4 matrix-vector multiplications with $A$
            %~ \item[\iarrow] solve one problem of type
              %~ \begin{equation*}
                %~ \min_{z \in \Delta_1 \times \Delta_2} c^Tz
              %~ \end{equation*}
            \item[\iarrow] 2 projections
              \begin{equation*}
                \min_{z \in \Delta_1 \times \Delta_2} \frac{1}{2} \norm{z - b}^2% - \langle b, z\rangle
              \end{equation*}
          \end{itemize}
          \vspace{1em}
          $\leadsto$ $\mathcal{O}(m_1 m_2 + m_1 \log(m_1) + m_2\log(m_2))$
    \end{itemize}
  \end{itemize}
  %~ \emph{convergence rate? $f(x_k) - f(x) \leq c/(k+1)^2$}
  %~ \emph{Is it clear with what complexity to solve these sup-problems? And should we maybe even reduce the notation further?}
\end{frame}


\begin{frame}{Nesterov algorithm}
  \begin{itemize}[itemsep=0.75em]
    \item $\mu := \frac{\eps}{2}$, $(w_0, z_0) = (x_0, y_0)$
    \item \textbf{for} $k = 0,\dots$
    \begin{itemize}[itemsep=0.75em]
      \item $(u_k, v_k) = \frac{2}{k+2} (w_k, z_k) + \frac{k}{k+2} (x_k, y_k)$
      \item $(x_{k+1}, y_{k+1}) = \argmin_{(x,y) \in \Delta_1 \times \Delta_2} \nabla F_\mu(u_k, v_k)^T\left((x,y) - (u_k, v_k)\right)$
        \newline \phantom{.} \hspace{15em} $ + \frac{\norm{A}^2}{2\mu} \norm{(x,y) - (u_k, v_k)}^2$
      \item \textbf{return if} $F(x_{k+1}, y_{k+1}) < \eps$
      \item $(w_{k+1}, z_{k+1}) = \argmin_{(w,z) \in \Delta_1 \times \Delta_2} \dots$
        \newline \phantom{.} \hspace{8em} $\sum_{i=0}^k \frac{i+1}{2} \nabla F_\mu(u_i, v_i)^T\left((w,z) - (u_i,v_i)\right)$
        \newline \phantom{.} \hspace{8em} $ + \frac{\norm{A}^2}{2\mu} \norm{(w,z) - (x_0,y_0)}^2$
    \end{itemize}
  \end{itemize}
\end{frame}


\begin{frame}{An $\mathcal{O}(\log(1/\eps))$ first order method}
  \begin{itemize}[itemsep=1.5em]
    \item %\textbf{Algorithm}
      \textbf{Gilpin/Pe\~n{a}/Sandholm '12:}
      \begin{itemize}[itemsep=0.6em]
        \item $\eps_0 := F(x_0, y_0)$
        \item for $i = 0,1,\dots$
        \begin{itemize}[itemsep=0.4em]
          \item $\eps_{i+1} := \frac{\eps_i}{e}$
          \item $(x_{i+1}, y_{i+1}) = \operatorname{Nesterov}(\eps_{i+1})$
          \item stop if $F(x_{i+1}, y_{i+1}) \leq \eps$
        \end{itemize}
      \end{itemize}
  
    \pause
    \vspace{1.5em}
    \end{itemize}
    %~ \item
      %~ \textbf{Theorem (Gilpin/Pe\~n{a}/Sandholm '12):}
        \begin{itemize}
          \item
            %~ Convergence to $\eps$-Nash equilibrium in at most
            %~ \begin{equation*}
              %~ k = \left \lceil 4e \norm{A} \delta(A) \log(2\norm{A}/\eps) \right \rceil
            %~ \end{equation*}
            \ssubcapbf{Bound on $\operatorname{Nesterov}()$ iterations}
            %~ $\eps$-Nash equilibrium in
            \begin{align*}
              k & = \left \lceil 4e \norm{A} \delta(A) \log(2\norm{A}/\eps) \right \rceil
              \\ & 
              \\ \delta(A) & := \sup_{z, \, F(z) \neq 0}
                \ \ \inf_{z^\ast, \, F(z^\ast) = 0}
                \ \ \frac{\norm{z - z^\ast}}{\abs{F(z) - F(z^\ast)}}
              \hspace{5em}
            \end{align*}
        \end{itemize}
  %~ \end{itemize}
\end{frame}

%~ \begin{frame}{Equilibrium finding in $\mathcal{O}(\log(1/\epsilon))$}
  %~ \begin{itemize}
    %~ \item \ssubcapbf{Non-smooth primal-dual problem}
      %~ \newline \quad $f(x) := \max_{u \in \Delta_2} x^TAu$, $\phi(y) := \min_{v \in \Delta_1} v^TAy$
      %~ \begin{equation*}
        %~ \min_{x \in \Delta_1} f(x) \ \Longleftrightarrow \ \max_{y \in \Delta_2} \phi(y)
      %~ \end{equation*}
      
    %~ \item \ssubcapbf{gap minimization}
      %~ \begin{equation*}
        %~ \min_{(x,y) \in \Delta_1 \times \Delta_2} F(x,y) = f(x) - \phi(y)
      %~ \end{equation*}
  %~ \end{itemize}
%~ \end{frame}


%~ \begin{frame}{Speed-up by sampling}
  %~ \emph{TODO -- read that paper first}
%~ \end{frame}

\tikzset{
    gametriangle/.style={
        draw=white,
        shape border rotate=0,
        regular polygon,
        regular polygon sides=3,
        fill=fu-light-blue,
        node distance=8em,
    }
}

\begin{frame}{Game abstraction: conceptional overview}
  \hspace{2em}
  \begin{tikzpicture}
    \node[gametriangle, label={full game}, minimum width=10em] (A) at (0,0) {};
    \node[gametriangle, label={abstract game}, minimum width=4em] (B) at ([xshift=17em]A) {};
    \node[gametriangle, minimum width=4em] (C) at ([yshift=-11em]B) {};
    \node[gametriangle, minimum width=10em] (D) at ([yshift=-11em]A) {};
    
    \draw[-stealth,ultra thick,rounded corners=100,color=fu-blue] ([xshift=1em]A.east) -- ([xshift=-1em]B.west) node[midway,above] {restriction};
    \draw[-stealth,ultra thick,rounded corners=100,color=fu-blue] ([yshift=-1em]B.south) -- ([yshift=1em]C.north) node[midway,right] {equilibrium finding};
    \draw[-stealth,ultra thick,rounded corners=100,color=fu-blue] ([xshift=-1em]C.west) -- ([xshift=1em]D.east) node[midway,above] {prolongation};
    
    \draw[ultra thick, color=red]
      ([yshift=-0.15em]C.north)
      -- ([xshift=-0.25em,yshift=-1.15em]C.north)
      -- ([xshift=0.25em,yshift=-2.3em]C.north)
      -- ([yshift=0.1em]C.south);
    
    \draw[line width=2.5pt, color=red]
      ([yshift=-0.15em]D.north)
      -- ([xshift=-0.6125em,yshift=-2.9em]D.north)
      -- ([xshift=0.6125em,yshift=-5.8em]D.north)
      -- ([yshift=0.1em]D.south);
  \end{tikzpicture}
\end{frame}


\begin{frame}{Restriction framework} % what is required?
  \begin{itemize}[itemsep=1.25em]
    \item
      \begin{itemize}[itemsep=0.75em]
        \item
          \begin{tabular}{ll}
            $G = (V,E,P,\cI,\cA,u,p)$ & game
            \\ $\wt{G} = (\wt{V},\wt{E},\wt{P},\wt{\cI},\wt{\cA},\wt{u},\wt{p})$ & abstract game
          \end{tabular}
      \end{itemize}
      
    \item \ssubcapbf{Abstraction choices}
      \begin{itemize}
        \item
          \begin{tabular}{ll}
            $\Pi_V\colon V \rightarrow \wt{V}$ & vertices
            \\ $\Pi_{\cI}\colon \cI \rightarrow \wt{\cI}$ & information sets
            \\ $\Pi_{\cA}\colon  \cA \rightarrow \wt{\cA}$ & actions
          \end{tabular}
      \end{itemize}
      
    %~ \item various \ssubcapbf{consistency requirements}
    
    %~ \item \ssubcapbf{induced quantities}
      %~ \begin{itemize}
        %~ \item
          %~ \begin{tabular}{ll}
            %~ $\wt{P}(\wt{v}) = P(\Pi_V^{-1}(\wt{v}))$ & player turns
          %~ \end{tabular}
      %~ \end{itemize}
  \end{itemize}
  %~ \emph{TODO: Use of this slide?}
\end{frame}


\begin{frame}{Prolongation}
  \begin{itemize}[itemsep=1.5em]
    \item
      Abstract strategy $\wt{\sigma}$
  
    \item
      \ssubcapbf{Lifted strategy}
      \begin{equation*}
        \wt{\sigma}(\Pi_{\cI}(I),\wt{a}) = \sum_{a \in \Pi_{\cA}^{-1}(\wt{a})} \sigma(I, a)
        \qquad\quad\forall{I \in \cI_k} \ \forall{\wt{a} \in \wt{\cA}_{\Pi_{\cI}(I)}}
        \phantom{.}\hspace{4em}
      \end{equation*}
      
    \item
      \ssubcapbf{Undivided strategy}
      \begin{equation*}
        \frac{\wt{\sigma}_{-0}(\wt{v})}{\wt{\sigma}_{-0}(f(I))}
        = \sum_{v \in \Pi_V^{-1}(\wt{v}) \cap I} \frac{\sigma_{-0}(v)}{\sigma_{-0}(I)}
         \qquad\quad\forall{I \in \cI_k} \ \forall{\wt{v} \in \Pi_{\cI}(I)}
        \phantom{.}\hspace{4em}
      \end{equation*}
  \end{itemize}
\end{frame}


\begin{frame}{A bound on approximation quality}
  %~ \emph{TODO fix definition at leaf nodes}
  \begin{itemize}[itemsep=2em]
    \item \ssubcapbf{Abstraction pathology}
      \begin{equation*}
        \exists{\text{``} \wt{G}_{\text{fine}} \subseteq \wt{G}_{\text{coarse}}\text{''}}\colon
        \ \inf_{\sigma^2} \, u_1\left(\sigma^1_{\text{fine}}, \sigma^2\right)
        \leq \inf_{\sigma^2} \, u_1\left(\sigma^1_{\text{coarse}}, \sigma^2\right)
        %~ \text{``}\wt{G}_{\text{fine}} \subseteq \wt{G}_{\text{coarse}}\text{''}
        %~ \ \centernot \implies \ \inf_{\sigma^2} u_1(\sigma^1_{\text{fine}}, \sigma^2) \geq \inf_{\sigma^2} u_1(\sigma^1_{\text{coarse}}, \sigma^2)
      \end{equation*}
      
  
    \pause
    \item
      \textbf{Kroer/Sandholm '14:} (here: for $P_0 = \emptyset$)
      \begin{itemize}[itemsep=0.75em]
        \item
          Nash equilibrium $\wt{\sigma}$ of $\wt{G}$
          
        \item
          undivided lifted strategy~$\sigma$ %of $\wt{\sigma}$
          
        \item
          $\Longrightarrow$ $\sigma$ is $\eps$-Nash equilibrium
          \begin{equation*}
            \eps := 2\norm{u - \wt{u} \circ \Pi_V}_\infty
            \phantom{.}\hspace{8em}
          \end{equation*}
      \end{itemize}
  \end{itemize}
\end{frame}


\begin{frame}{Challenge: Computing abstractions}
  \begin{itemize}[itemsep=2em]
    \item \ssubcapbf{Level-by-level clustering}
      \begin{itemize}[itemsep=0.75em]
        \item \vspace{0.75em} vertices $S \subseteq V$ with identical actions $A$
        \item $c(a_1, a_2) = \operatorname{Similarity}(S, a_1, a_2)$ for $a_1, a_2 \in A$
        \item $\wt{A} = \operatorname{Cluster}(A, c)$
      \end{itemize}
    
    \item \ssubcapbf{Integer programming}
      \begin{align*}
        \min_{\delta_{ij}, p_i} & \sum_{v,w\in \Vleaf} \norm{u(v) - u(w)}_\infty \delta_{ij}
        \\ \sum_{j \in V} \delta_{ij} & \leq 1,
        \quad p_i + \sum_{j \in V} \delta_{ij} \geq 1,
        \quad \delta_{ji} - p_i \leq 0,
        \quad \dots
      \end{align*}
        
      %~ \begin{itemize}
        %~ \item problem-dependent similarity metrics
        %~ \item clustering algorithms
        %~ \item integer programming
      %~ \end{itemize}
  \end{itemize}

  %~ \begin{itemize}
    %~ \item
      %~ \emph{NP-hardness result}
      
    %~ \item
      %~ \emph{state-of-the art: integer programming}
  %~ \end{itemize}
  %~ \emph{todo: read sandholm's abstraction review paper}
\end{frame}


%~ \begin{frame}{Consistency requirements}
  %~ \begin{itemize}
    %~ \item $\Pi_{\cA}(a_1) = \Pi_{\cA}(a_2) \ \Longrightarrow \ \Pi_{V}(
    %~ \item 
  %~ \end{itemize}
%~ \end{frame}


%~ \begin{frame}{Consistency requirement: multi-map $\phi$}
  %~ \emph{TODO: Explain use/necessity of this}
  %~ \begin{itemize}
    %~ \item $V_\phi \subseteq V$
    %~ \item $\phi\colon V_\phi \rightarrow 2^{\wt{V}}$
  %~ \end{itemize}
%~ \end{frame}


%~ \begin{frame}{Error measures}
  %~ \emph{maybe -- TODO}
%~ \end{frame}


%~ \begin{frame}{A class of feasible abstractions}
  %~ \emph{TODO}
%~ \end{frame}


%~ \begin{frame}{A bound on approximation quality}
  %~ \emph{TODO fix definition at leaf nodes}
  %~ \begin{itemize}[itemsep=1em]
    %~ \item
      %~ \ssubcapbf{Reward approximation error} $\eps^R := \eps_{\operatorname{root}}^R$
      %~ \begin{align*}
        %~ \eps_{v}^R :=
        %~ \begin{cases}
          %~ \max_{\wt{v} \in \phi(v)} \norm{u(v) - \wt{u}(\wt{v})}_\infty & v \in \Vleaf
          %~ \\ \max_{a \in \cA(v)} \, \eps^R_{\operatorname{tar}(v,a)} & P(v) \neq 0
          %~ \\ \sum_{a \in \cA(v)} p(v,a) \, \eps^R_{\operatorname{tar}(v,a)} & P(v) = 0
        %~ \end{cases}
      %~ \end{align*}
      
    %~ \item
      %~ \ssubcapbf{Nature distribution error}
    
    %~ \item
      %~ \textbf{Theorem (Kroer/Sandholm '14):}
      %~ \begin{itemize}
        %~ \item
          %~ Suppose a Nash equilibrium $\wt{\sigma}$ of $\wt{G}$.
          %~ There exist $c > 0$ such that
          %~ every undivided lifted
          %~ strategy~$\sigma$ of $\wt{\sigma}$ is an $\eps$-Nash equilibrium of $G$ with
          %~ \vspace{0.5em}
          %~ \begin{itemize}
            %~ \item
              %~ $\eps := 2\eps^R + c\,\eps^0 \norm{\wt{u}}_\infty
              %~ %\sum_{??} \eps_j^0 \overline{W} + \sum_{??} 2 \eps_j^0 \overline{W}
              %~ \text{.}$
          %~ \end{itemize}
          %~ %~ \vspace{0.5em}
          %~ %~ There exist pairs $(G,\wt{G})$ such that this bound is tight up to a constant factor.
      %~ \end{itemize}
  %~ \end{itemize}
%~ \end{frame}


\begin{frame}[allowframebreaks]{Literature}
  \scriptsize
  \nocite{BroSan18}
  \nocite{Johanson13}
  \nocite{Kuhn53}
  \nocite{Nash51}
  \nocite{Neumann28}
  \nocite{Nesterov05}
  \nocite{LaLuMo11}
  \nocite{GiPeSa12}
  \nocite{KroSan14}
  \nocite{Sandholm10}
  \bibliographystyle{plain}
  \bibliography{references}
  %~ \begin{thebibliography}{99}
      %~ \bibitem{superhumanai}
        %~ A.M.~Antonopoulos.
        %~ \emph{Mastering Bitcoin. Programming the Open Blockchain},
        %~ second edition, O'Reilly, 2017.
  %~ \end{thebibliography}
\end{frame}

  %~ \pagenumbering{gobble}

%~ \begin{frame}{}
  %~ \vfill
  %~ \begin{center}
    %~ \textbf{\huge Thank you! \ \ \ }
  %~ \end{center}
  %~ \vfill
%~ \end{frame}


% Could extend talk by:
% - Talking more in the beginning (details of the competition)
% - Talk about why perfect-information techniques will not work (due to inter-dependencies), best by giving some example
% - Talk in the end a little about endgame solving
% - Talk about outlooks and challenges (like >2 player games, non-zero sum games)
% - Tell at some point why Nash equilibrium is a reasonable concept in 2-player zero sum games
% - could be more explicit on the possible applications

\end{document}
